#include <stdio.h>
#include <stdlib.h>

long long int nzd(long long int a, long long int b)
{
    if(b>a)
    {
        long long int temp=b;
        b=a;
        a=temp;
    }
    long long int r;
    while(b)
    {
        r=a%b;
        a=b;
        b=r;
    }
    return(a);
}

int main()
{
    int t;
    scanf("%d",&t);
    int prnt[t];
    for(int i=0;i<t;i++)
    {
        int n,m;
        scanf("%d%d",&n,&m);

        long long int a[n];
        long long int b[m];
        for(int j=0;j<n;j++)
        {
            scanf("%lli",&a[j]);
        }
        for(int j=0;j<m;j++)
        {
            scanf("%lli",&b[j]);
        }

        if(m==0)
        {
            prnt[i]=1;
        }
        else
        {
            for(int j=0;j<n-1;j++)
            {
                for(int k=j+1;k<n;k++)
                {
                    if(a[j]>a[k])
                    {
                        long long int temp=a[j];
                        a[j]=a[k];
                        a[k]=temp;
                    }
                }
            }
            for(int j=0;j<m-1;j++)
            {
                for(int k=j+1;k<m;k++)
                {
                    if(b[j]>b[k])
                    {
                        long long int temp=b[j];
                        b[j]=b[k];
                        b[k]=temp;
                    }
                }
            }

            long long int min;
            if(n!=2)
            {
                min=nzd(a[1]-a[0],a[2]-a[1]);
                for(int j=3;j<n;j++)
                {
                    min=nzd(min,a[j]-a[j-1]);
                }
            }
            else
                min=a[1]-a[0];

            if(min==1)
            {
                prnt[i]=0;
            }
            else
            {
                long long int br=0;
                for(int j=0;j<m && br==0;j++)
                {
                    long long int k;
                    for(k=a[0] ; k<b[j] ; k+=min)
                    {
                    }
                    if(k==b[j])
                    {
                        br++;
                    }
                }
                if(br==0)
                    prnt[i]=1;
                else
                    prnt[i]=0;
            }
        }
    }
    for(int i=0;i<t;i++)
        printf("%d\n",prnt[i]);
}